﻿@page "/changenames"
@inject HttpClient Http
@inject NavigationManager NavigationManager
@inject AuthenticationStateProvider AuthStateProvider

<MudGrid Justify="Justify.Center">
    <MudItem xs="12" sm="8" md="6" lg="4" xl="3">
        <MudPaper Elevation="8" Class="pa-4">
            <MudTabs>
                <MudTabPanel Text="Change password">
                    <MudForm @ref="form" @bind-IsValid="isValid">
                        <MudTextField Label="New First Name" Variant="Variant.Filled" @bind-Value="putUserModel.FirstName" Required="true" RequiredError="First Name is required!" FullWidth />
                        <MudTextField Label="New Last Name" Variant="Variant.Filled" @bind-Value="putUserModel.LastName" Required="true" RequiredError="Last Name is required!" FullWidth />
                        <MudButton Variant="Variant.Filled" Color="Color.Primary" Class="mt-4" OnClick="HandlePut">Log in</MudButton>
                    </MudForm>
                </MudTabPanel>
            </MudTabs>
        </MudPaper>
    </MudItem>
</MudGrid>

@code {
    private MudForm form;
    private PutUserModel putUserModel = new PutUserModel();
    private bool isValid;
    private bool loginFailed;
    private string errorMessage;

    private async Task HandlePut()
    {
        await form.Validate();

        if (isValid)
        {
            var success = await PutAsync(putUserModel);
            if (success)
            {
                NavigationManager.NavigateTo("/showusers");
            }
            else
            {
                loginFailed = true;
                errorMessage = "Wrong credentials, please check and try again.";
            }
        }
    }

    public async Task<bool> PutAsync(PutUserModel putUserModel)
    {
        var response = await Http.PatchAsJsonAsync("/api/Users", putUserModel);
        return response.IsSuccessStatusCode;
    }
}
